/*
   The Soma Project

   Copyright 2007 Rachel Pasetes, John Burr, Sean Eves Knudsen,
                  Thomas Gerdes, Andrew Parra, Erik Pasternak

  This file is part of The Soma Project.

  The Soma Project is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  The Soma Project is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with The Soma Project; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/*!@file
   @ingroup command
   @brief OC related functions
*/

/*!@fn oc_Init( void )
   @brief Initializes the output compare
   @Initializes the output compare by setting
   @specific registers in output compare.
*/
inline void oc_Init( void );

/*!@fn oc_TurnServo(int16_t degree)
   @brief Turns the servo motor a set number of degrees
*/
void oc_TurnServo(int16_t degree);

/*!@fn oc_GetServoAngle( void )
   @brief Returns the current angle the servo is turned to
*/
int16_t oc_GetServoAngle( void );
