#ifdef TOFRECEIVETEST
#warning compiling for TOFRECEIVETEST

#include "RF.h"
#include "util.h"
#include "usart.h"
#include "spi.h"
#include "sram.h"
#include "oc.h"
#include "ic.h"
#include <stdio.h>
#include "localcom.h"
#include "triglookup.h"
#include "Packet.h"
#include <assert.h>

void ReceiveTOF( void ) {
   uint8_t temp[4];

   uint16_t tof1, tof2, tof3;
   uint16_t d_ad, d_bd, d_cd;
   uint8_t reply;
   uint8_t validFlag;

   int16_t x_rel, y_rel, distance;
   uint16_t IROnTime, USDistance1, USDistance2, USDistance3;

   printf("issuing EXPECTIR...");
   reply = Local_ExpectIR();
   printf("EXPECTIR acknowledged with %u...", reply);

   reply = Local_WaitForData();
   if ( reply == TOF_DATA ) {
      SELECT_LOCALIZE();
      reply = SPI_Transfer(TOF_DATA_ACK); //ack
      //DESELECT_LOCALIZE();
      //printf("reply after TOF_DATA ack = %u\n\r", reply);
      printf("TOF_DATA ack = %u...", reply);
      //SELECT_LOCALIZE();
      validFlag = SPI_Transfer(NO_DATA) == TOF_DATA ? 1 : 0;
      
      x_rel = SPI_Transfer(NO_DATA)<<8;
      x_rel |= SPI_Transfer(NO_DATA);
      y_rel = SPI_Transfer(NO_DATA)<<8;
      y_rel |= SPI_Transfer(NO_DATA);
      /*distance = SPI_Transfer(NO_DATA)<<8;
      distance |= SPI_Transfer(NO_DATA);
      d_ad = SPI_Transfer(NO_DATA)<<8;
      d_ad |= SPI_Transfer(NO_DATA);
      d_bd = SPI_Transfer(NO_DATA)<<8;
      d_bd |= SPI_Transfer(NO_DATA);
      d_cd = SPI_Transfer(NO_DATA)<<8;
      d_cd |= SPI_Transfer(NO_DATA);*/
      
      DESELECT_LOCALIZE();
      if ( validFlag ) {
         printf("valid data received\n\r");
         //printf("\n\n\x_rel = %04X\ttof2 = %04X\ttof3 = %04X\n\r", tof1, tof2, tof3);
         //printf("d_ad = %umm,\td_bd = %umm,\td_cd = %umm\n\n\r", d_ad, d_bd, d_cd);
         //printf("x_rel = %dmm,\ty_rel = %dmm,\tdistance = %dmm\n\n\r", x_rel, y_rel, distance);
         printf("x_rel = %dmm,\ty_rel = %dmm\n\n\r", x_rel, y_rel);
      } else {
         printf("INVALID data received\n\r");
         //printf("\n\n\rtof1 = %04X\ttof2 = %04X\ttof3 = %04X\n\r", tof1, tof2, tof3);
         //printf("d_ad = %umm,\td_bd = %umm,\td_cd = %umm\n\n\r", d_ad, d_bd, d_cd);
         //printf("x_rel = %dmm,\ty_rel = %dmm,\tdistance = %dmm\n\n\r", x_rel, y_rel, distance);
         printf("x_rel = %dmm,\ty_rel = %dmm\n\n\r", x_rel, y_rel);
      }
      
      /*tof1 = SPI_Transfer(NO_DATA)<<8;
      tof1 |= SPI_Transfer(NO_DATA);
      tof2 = SPI_Transfer(NO_DATA)<<8;
      tof2 |= SPI_Transfer(NO_DATA);
      tof3 = SPI_Transfer(NO_DATA)<<8;
      tof3 |= SPI_Transfer(NO_DATA);
      
      DESELECT_LOCALIZE();
      if ( validFlag ) {
         printf("valid data received\n\r");
         printf("\n\n\rtof1 = %04X\ttof2 = %04X\ttof3 = %04X\n\r", tof1, tof2, tof3);
         printf("USDistance1 = %umm,\tUSDistance2 = %umm,\tUSDistance3 = %umm\n\n\r", tof1, tof2, tof3);
      } else {
         printf("INVALID data received\n\r");
         printf("\n\n\rtof1 = %04X\ttof2 = %04X\ttof3 = %04X\n\r", tof1, tof2, tof3);
         printf("USDistance1 = %umm,\tUSDistance2 = %umm,\tUSDistance3 = %umm\n\n\r", tof1, tof2, tof3);
      }*/

   } else {
      printf("fuck thom!!!!!!!!!!!! reply = %u\n\r", reply);
      assert(0);
      /*SELECT_LOCALIZE();
      SPI_Transfer(TOF_INVALID_ACK);
      DESELECT_LOCALIZE();
      SELECT_LOCALIZE();
      tof1 = SPI_Transfer(NO_DATA)<<8;
      tof1 |= SPI_Transfer(NO_DATA);
      tof2 = SPI_Transfer(NO_DATA)<<8;
      tof2 |= SPI_Transfer(NO_DATA);
      tof3 = SPI_Transfer(NO_DATA)<<8;
      tof3 |= SPI_Transfer(NO_DATA);
      DESELECT_LOCALIZE();
      printf("invalid data received from localize. reply = %u\n\r", reply);
      printf("tof1 = %04X\ttof2 = %04X\ttof3 = %04X\n\r", tof1, tof2, tof3);
      printf("USDistance1 = %umm,\tUSDistance2 = %umm,\tUSDistance3 = %umm\n\n\r", tof1, tof2, tof3);*/
   }
   _delay_sec(1);
}

int main( void ) {
   
   asm("cli");
   SPI_Init(MASTER);
   USART0_Init( BAUD57600 );

   SET_BIT( DDRB, DDB4 );  //Set PB4 as an output (Localize SS')
   //SELECT_LOCALIZE();
   
   asm("sei");

   while( 1 ) {
      ReceiveTOF();
   }

   return 0;
}

#endif
