/*
   The Soma Project

   Copyright 2007 Rachel Pasetes, John Burr, Sean Eves Knudsen,
                  Thomas Gerdes, Andrew Parra, Erik Pasternak

  This file is part of The Soma Project.

  The Soma Project is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  The Soma Project is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with The Soma Project; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/*!@file
   @ingroup localize
   @brief iRobot Create control module

   This file contains code to control the iRobot Create over a UART
*/
#if !defined( IROBOT_H )
#define IROBOT_H
#include <inttypes.h>

void iRobot_Init(void);
void iRobot_ModeSafe(void);
void iRobot_ModeFull(void);
void iRobot_ChangeBaud(uint8_t c);
void iRobot_Drive(int16_t left_speed, int16_t right_speed);
void iRobot_Drive_Distance_Fwd( int16_t distance, int16_t speed );
void iRobot_Drive_Distance_Rev( int16_t distance, int16_t speed );
void iRobot_Wait(int8_t time);
int16_t iRobot_GetCliffLeft(void);
void iRobot_SongStore(int8_t slot, int8_t length, int8_t* song);
void iRobot_SongPlay(int8_t slot);
void iRobot_PlayLedOn(void);
int16_t iRobot_GetDistance(void);
int16_t iRobot_GetAngle(void);

#endif
