#include "usart.h"
#include <avr/io.h>
#include <stdio.h>
#include <util/delay.h>
#include "spi.h"
#include "../share/util.h"
#include "SignalGeneration.h"
#include "localcom.h"
#include "triglookup.h"
#include "TOFcom.h"


#ifdef TOFTRANSMITTEST
#warning compiling for TOFTRANSMITTEST

int main( void ) {
   asm("cli");
   SG_Init();
   asm("sei");
   while ( 1 ) {
      SG_Start();
      _delay_sec( 1 );
   }
   return 0;
}
#endif

#ifdef TOFRECEIVETEST
#warning compiling for TOFRECEIVETEST

int main( void ) {
   uint8_t cmd, expectir_reply = 0xAA, requestdata_reply = 0x55;
   uint8_t temp;
   uint8_t in[4];
   uint8_t out[4] = { NO_DATA, NO_DATA, NO_DATA, NO_DATA };

   uint32_t d_ad, d_bd, d_cd, distance;
   int32_t x_rel, y_rel; 

   uint8_t i = 0;
   uint8_t mcu;
   uint8_t currentIndex;

   asm("cli");
   SG_Init();
   TOF_Init();
   SPI_Init(SLAVE);
   asm("sei");

   /*while ( 1 ) {
      SELECT_TOF(TOF1);
      USART0_Transfer( 0x5A );
      _delay_us(50);
      DESELECT_TOF(TOF1);
      _delay_ms(10);
   }*/

   while ( 1 ) {
      cmd = SPI_Transfer(NO_DATA);
      switch ( cmd ) {
         case EXPECTIR:
            SPI_Transfer( EXPECTIR_ACK );
            SPI_Transfer( NO_DATA );

            _delay_us(50);
            expectir_reply = TOF_ExpectIR( TOF1 );
            _delay_sec(3);
            requestdata_reply = TOF_RequestData( TOF1 );
            
            _delay_us(50);
            expectir_reply = TOF_ExpectIR( TOF2 );
            _delay_sec(3);
            requestdata_reply = TOF_RequestData( TOF2 );
            
            _delay_us(50);
            expectir_reply = TOF_ExpectIR( TOF3 );
            _delay_sec(3);
            requestdata_reply = TOF_RequestData( TOF3 );
            _delay_us(50);

            /*for ( mcu = TOF1; mcu <= TOF1; mcu++ ) {
               currentIndex = mcu - CSOFFSET;
               if ( TOF_Data.valid[currentIndex] == 1 ) {
                  while( SPI_Transfer( TOF_DATA ) != TOF_DATA_ACK);
                  SPI_Transfer( (uint8_t)(TOF_Data.IR[currentIndex]>>8) );
                  SPI_Transfer( (uint8_t)(TOF_Data.IR[currentIndex] & 0x00FF) );
                  SPI_Transfer( (uint8_t)(TOF_Data.TOF[currentIndex]>>8) );
                  SPI_Transfer( (uint8_t)(TOF_Data.TOF[currentIndex] & 0x00FF) );
                  SPI_Transfer( 0xFF );
                  SPI_Transfer( 0xFF );
               } else {
                  while( SPI_Transfer( TOF_INVALID ) != TOF_INVALID_ACK );
                  SPI_Transfer( expectir_reply );
                  SPI_Transfer( requestdata_reply );
                  SPI_Transfer( (uint8_t)(TOF_Data.IR[currentIndex]>>8) );
                  SPI_Transfer( (uint8_t)(TOF_Data.IR[currentIndex] & 0x00FF) );
                  SPI_Transfer( (uint8_t)(TOF_Data.TOF[currentIndex]>>8) );
                  SPI_Transfer( (uint8_t)(TOF_Data.TOF[currentIndex] & 0x00FF) );
               }
            }*/

            //TOF_Data.valid[0] = 1;
            //TOF_Data.valid[1] = 1;
            //TOF_Data.valid[2] = 1;

            

            d_ad = TOF_Data.TOF[0]/6;
            d_bd = TOF_Data.TOF[1]/6;
            d_cd = TOF_Data.TOF[2]/6;
            /*// test data.  results in x_rel = 0, y_rel = 1622.
            d_ad = 1524;
            d_bd = 1702;
            d_cd = 1702;*/

            distance = (d_ad + d_bd + d_cd)/3;

            x_rel = ((d_bd * d_bd) - (d_cd * d_cd))/408;
            y_rel = (78-(2*(d_ad * d_ad))+(d_bd * d_bd)+(d_cd * d_cd))/708;

            for ( i = 0; i < 3; i++ ) {
               if ( (TOF_Data.IR[i]/2 < 350) || 
                    (TOF_Data.IR[i]/2 > 650) || 
                    (TOF_Data.TOF[i]/6 < 100) ||
                    (TOF_Data.TOF[i]/6 > 3049) ) {
                  TOF_Data.valid[i] = 0;
               }
            }
            
            
            while( SPI_Transfer( TOF_DATA ) != TOF_DATA_ACK);
            //send data to command

            if ( (TOF_Data.valid[0] == 1) && (TOF_Data.valid[1] == 1) && (TOF_Data.valid[2] == 1) ) {
               SPI_Transfer( TOF_DATA );
            } else {
               SPI_Transfer( TOF_INVALID );
            }
            SPI_Transfer((uint8_t)(((int16_t)x_rel)>>8));
            SPI_Transfer((uint8_t)(((int16_t)x_rel) & 0x00FF));
            SPI_Transfer((uint8_t)(((int16_t)y_rel)>>8));
            SPI_Transfer((uint8_t)(((int16_t)y_rel) & 0x00FF));
            
            /*SPI_Transfer((uint8_t)(((int16_t)distance)>>8));
            SPI_Transfer((uint8_t)(((int16_t)distance) & 0x00FF));
            SPI_Transfer((uint8_t)(((int16_t)d_ad)>>8));
            SPI_Transfer((uint8_t)(((int16_t)d_ad) & 0x00FF));
            SPI_Transfer((uint8_t)(((int16_t)d_bd)>>8));
            SPI_Transfer((uint8_t)(((int16_t)d_bd) & 0x00FF));
            SPI_Transfer((uint8_t)(((int16_t)d_cd)>>8));
            SPI_Transfer((uint8_t)(((int16_t)d_cd) & 0x00FF));*/
            /*SPI_Transfer((uint8_t)(TOF_Data.TOF[0]>>8));
            SPI_Transfer((uint8_t)(TOF_Data.TOF[0] & 0x00FF));
            SPI_Transfer((uint8_t)(TOF_Data.TOF[1]>>8));
            SPI_Transfer((uint8_t)(TOF_Data.TOF[1] & 0x00FF));
            SPI_Transfer((uint8_t)(TOF_Data.TOF[2]>>8));
            SPI_Transfer((uint8_t)(TOF_Data.TOF[2] & 0x00FF));*/
            break;
         default:
            ;
      }
   }
   return 0;
}

#endif
