/*
   The Soma Project

   Copyright 2007 Rachel Pasetes, John Burr, Sean Eves Knudsen,
                  Thomas Gerdes, Andrew Parra, Erik Pasternak

  This file is part of The Soma Project.

  The Soma Project is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  The Soma Project is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with The Soma Project; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/*!@file
   @ingroup share
   @brief SPI commands

   This file contains all the commands sent over SPI.  Any command 
   sent should use the #defines, not the actual value, as they are
   subject to change.
*/

#ifndef _SPICOMMANDS_H_
#define _SPICOMMANDS_H_

typedef enum { NO_DATA=0,    //Response if data isn't ready yet.
               TOF_DATA,     //This is the request to send the TOF_Data back.
                             //Use it as the response, too, which will be followed with
                             //IR_ON time, then TOF_time.
               TOF_DATA_ACK,
               TOF_INVALID,  //Invalid TOF Data, so following data should be ignored
               TOF_INVALID_ACK,
               EXPECTIR,     //The receiving MCU should expect IR.
               EXPECTIR_ACK,
               GETXY,
               GETSEENXY,
               SEND_POSITION,
               SEND_COMMAND,
               XY,
               SPI_ACK,
               ROBOTTURN90,
               ROBOTSTOP,
               ROBOTDRIVE } COMMANDS;

#endif
