/*
   The Soma Project

   Copyright 2007 Rachel Pasetes, John Burr, Sean Eves Knudsen,
                  Thomas Gerdes, Andrew Parra, Erik Pasternak

  This file is part of The Soma Project.

  The Soma Project is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  The Soma Project is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with The Soma Project; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/*!@file
   @ingroup localize
   @brief Common Localize functions
*/

#include <avr/io.h>
#include "util.h"
#include "localcom.h"

void init_Chip_Select_Localize( void ){
   SET_BIT( DDRB, DDB4 );  //Set PB4 as an output
   CLR_BIT( PORTB, PB4 );
}

uint8_t Local_ExpectIR() {
   uint8_t reply;
   SELECT_LOCALIZE();
   while( (reply = SPI_Transfer(EXPECTIR)) != EXPECTIR_ACK ) {  // send EXPECTIR until acknowledged
      //DESELECT_LOCALIZE();
      //printf("waiting for EXPECTIR_ACK, reply = %u\n\r", reply);
      //SELECT_LOCALIZE();
      ;
   }
   DESELECT_LOCALIZE();
   return reply;
}

uint8_t Local_WaitForData() {
   uint8_t reply;
   SELECT_LOCALIZE();
   while( (reply = SPI_Transfer(NO_DATA)) == NO_DATA ) {  // poll until something other than NO_DATA is returned
      //DESELECT_LOCALIZE();
      //printf("waiting for !=NO_DATA, reply = %u\n\r", reply);
      //SELECT_LOCALIZE();
      ;
   }
   DESELECT_LOCALIZE();
   return reply;
}
