/*
   The Soma Project

   Copyright 2007 Rachel Pasetes, John Burr, Sean Eves Knudsen,
                  Thomas Gerdes, Andrew Parra, Erik Pasternak

  This file is part of The Soma Project.

  The Soma Project is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  The Soma Project is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with The Soma Project; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/*!@file
   @ingroup localize
   @brief SPI interface module

   This file contains code to control the iRobot Create over a UART
*/

#ifndef _LOCALCOM_H_
#define _LOCALCOM_H_

#include "../share/SPIcommands.h"

#define SELECT_LOCALIZE() CLR_BIT( PORTB, PB4 )
#define DESELECT_LOCALIZE() SET_BIT( PORTB, PB4 )

uint8_t Local_ExpectIR(void);
uint8_t Local_WaitForData(void);

/*!@fn void init_Chip_Select_Localize( void )
   @brief Sets the chip select to the localize board
   @Turns on the chip select on the localization
   @board.
*/
void init_Chip_Select_Localize( void );

#endif
