/*
   The Soma Project

   Copyright 2007 Rachel Pasetes, John Burr, Sean Eves Knudsen,
                  Thomas Gerdes, Andrew Parra, Erik Pasternak

  This file is part of The Soma Project.

  The Soma Project is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  The Soma Project is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with The Soma Project; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/*!@file mapData.h
   @brief Map Data Structure header
   @ingroup lib
*/
#ifndef _MAPDATA_H
#define _MAPDATA_H

#define MAPSIZE 20  /*!< Height and width of map data in each file */
/*!@fn unsigned char *getMapData(int x, int y, char lock)
   @brief Fetch pointer to pixmap of map.
   @param x x position of map.
   @param y y position of map.
   @param lock Set to 1 to keep this element in memory while modifying
   it
   @return pointer to pixmap data of map x,y
 */
unsigned char *getMapData(int x, int y, char lock);
/*!@fn void saveMapData(int x, int y)
   @brief Mark data ready to write back to disk.
   @param x x position of map
   @param y y position of map
   @note This function also releases any lock on the map data
 */
void saveMapData(int x, int y);

#endif
