/*
   The Soma Project

   Copyright 2007 Rachel Pasetes, John Burr, Sean Eves Knudsen,
                  Thomas Gerdes, Andrew Parra, Erik Pasternak

  This file is part of The Soma Project.

  The Soma Project is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  The Soma Project is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with The Soma Project; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/*!@file
   @brief Utility functions
   @ingroup lib
*/
#include "util.h"
#ifndef OBSERVE
#include <util/delay.h>
#endif

void charToHex(char *buf, char val) {
   unsigned char hi=(val & 0xF0) >> 4;
   unsigned char lo= val & 0x0F;
   if(hi < 10)
      buf[0]='0'+hi;
   else
      buf[0]='A'+hi-10;

   if(lo < 10)
      buf[1]='0'+lo;
   else
      buf[1]='A'+lo-10;
}
void shortToHex(char *buf, short val) {
   charToHex(buf, (val & 0xFF00) >> 8);
   charToHex(buf+2,val & 0x00FF);
}
void intToHex(char *buf, int val) {
   charToHex(buf, (val & 0xFFFF0000) >> 16);
   charToHex(buf+4,val & 0x0000FFFF);
}
#ifndef OBSERVE
void _delay_sec( int time ){
   int i, j;
   for( i = 0; i<time; i++ ){
	   for( j = 0; j<100; j++){
	      _delay_ms(10);
	   }
   }
}
#endif
