/*
   The Soma Project

   Copyright 2007 Rachel Pasetes, John Burr, Sean Eves Knudsen,
                  Thomas Gerdes, Andrew Parra, Erik Pasternak

  This file is part of The Soma Project.

  The Soma Project is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  The Soma Project is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with The Soma Project; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/*!@file usi.h
   @brief USI header
   @ingroup tof
*/

#ifndef _USI_H
#define _USI_H

#include "../share/util.h"
#include "../share/SPIcommands.h"

void USI_InitSPISlave( uint8_t spiMode );
void USI_InitSPIMaster( uint8_t spiMode );
void USI_Transmit( uint8_t data );
void USI_ClearTransmitComplete( void );
void USI_WaitForTransmitComplete( void );
void USI_WaitForBufferEmpty( void );
uint8_t USI_GetReceivedData( void );



#endif   //ifndef _USI_H
